#include "CS_Enemy_Pignon2.h"
#include "CS_PeSmoke.h"
#include "CS_Exp.h"
CS_Enemy_Pignon2::CS_Enemy_Pignon2()
{
	type = 2;
	ani.png = L"CS_CaveStoryMod";
	cbRect.enableCbRect = true;
	cbRect.enableSoild = true;
	cbRect.enableSelfSoild = true;
	cbRect.left = cbRect.right = 6;
	cbRect.top = cbRect.bottom = 5;
	cbRect.fullWaterBlock = true;
	hp_max = hp = 2;
	dropExp = 1;
	coyote_max = 0;
	damage_reset_counter = 60;
	attackState_reset_counter_max = 60;
	drawBeforeOtherEntity = true;
}

void CS_Enemy_Pignon2::Init(std::weak_ptr<Entity> self)
{
	stateGravity.Init(shared_from_this());
	stateResist.Init(shared_from_this());
	stateSplash.Init(shared_from_this());
	Entity::Init(self);
}

void CS_Enemy_Pignon2::Step()
{
	auto& ani_no = ani.image_index;
	//跟上移动平台
	Entity::BeginMovingPlatform();
	stateGravity.Step();
	stateResist.Step();
	stateSplash.Step();
	if (shock_counter == 0)
	{
		if (cbRect.cbLeft)
		{
			lr = 1;
			vx = 0x200 / ts;
		}
		if (cbRect.cbRight)
		{
			lr = 0;
			vx = -0x200 / ts;
		}
		if (lr == 0)
			vx = -0x100 / ts;
		else
			vx = 0x100 / ts;
		ani.sprite_index = lr == 0 ? L"ls_pignon_move_l" : L"ls_pignon_move_r";
	}
	else
	{
		ani.sprite_index = lr == 0 ? L"ls_pignon_hurt_l" : L"ls_pignon_hurt_r";
	}
	//跟上移动平台
	Entity::EndMovingPlatform();
	//执行运动
	Entity::Step();
	//掉头
	TurnBack();
	//清除最后一次碰撞结果
	Entity::ClearCollisionResult();
	//执行碰撞
	Entity::Collision();
	//维持在斜坡上
	Entity::KeepOnSlopes();
}

void CS_Enemy_Pignon2::SetState(int stateID, int lr)
{
	this->lr = lr;
	ani.sprite_index = lr == 0 ? L"ls_pignon_stand_l" : L"ls_pignon_stand_r";
	ani.image_index = 0;
}

void CS_Enemy_Pignon2::Attack(std::weak_ptr<Entity> dst, int* outDamage, float* outAngle, bool* outTakedown, int* outElemType, float* outShockForce, float* outHeavy)
{
	*outDamage = 1;
	auto wdst = dst.lock();
	if (wdst)
	{
		if (wdst->lr == 0)
		{
			*outAngle = 315;
		}
		else
		{
			*outAngle = 225;
		}
	}
	*outTakedown = true;
	*outElemType = 0;
	*outShockForce = 0x200 / ts;
	*outHeavy = 2;
}

bool CS_Enemy_Pignon2::Hurt(std::weak_ptr<Entity> src, int getDamage, float angle, bool bTakedown, int elemType, float shockForce, float heavy, int* outRealDamage)
{
	if (getDamage == 0)
		return false;
	*outRealDamage = getDamage;
	shock_counter = 30;
	hp -= getDamage;
	if (hp > 0)
	{
		gameFunc->PlaySound(L"CS_055_enemy_squeak2");
	}
	else
	{
		gameFunc->PlaySound(L"CS_071_little_crash");
		//创建云团
		SetCS_PeSmokeMedium(shared_from_this(), x, y);
		hp = 0;
		//掉落物品
		SetDropItem(shared_from_this(), x, y, dropExp);
		Destroy();
	}
	//伤害冲击处理
	if (shockForce > 0)
	{
		//被攻击弹反
		float radian = angle * deg2rad;
		vx = shockForce * cosf(radian);
		vy = shockForce * sinf(radian);
		vy -= 1;
	}
	vx = lr == 0 ? -1.0f : 1.0f;
	//显示伤害值
	if (gameFunc->dmgNum)
		gameFunc->SetDmgNum(gameFunc->dmgNum, getDamage, x, y - 16, 0, shared_from_this());
	return true;
}

void CS_Enemy_Pignon2::TurnBack()
{
	if (!cbRect.cbBottom)
		return;
	//如果前方是空地则掉头
	float srcX = x;
	float srcY = y;
	ignoreTrap = true;
	if (lr == 0)
	{
		x -= 4;
		y += 4;
		Entity::ClearCollisionResult();
		Entity::Collision();
		//如果下方是空的则掉头
		if (!cbRect.cbBottom || cbRect.onTrap)
		{
			lr = 1;
			vx = 0x200 / ts;
		}
	}
	else
	{
		x += 4;
		y += 4;
		Entity::ClearCollisionResult();
		Entity::Collision();
		//如果下方是空的则掉头
		if (!cbRect.cbBottom || cbRect.onTrap)
		{
			lr = 0;
			vx = 0x200 / ts;
		}
	}
	//复原
	x = srcX;
	y = srcY;
	ignoreTrap = false;
}

std::shared_ptr<Entity> CreateCS_Enemy_Pignon2()
{
	return std::make_shared<CS_Enemy_Pignon2>();
}
